#!/bin/bash

# update_loopaes.sh
# by WDef

# Try to unload old loop driver in case it's loaded.
# Update depfile for loop-aes-ciphers.


# Check kernel version

if [ $(uname -r) != 2.4.26 ]; then
	aterm -e whiptail --backtitle 'UPDATE LOOP-AES' \
				--title 'ERROR' \
	--msgbox "	WRONG KERNEL VERSION FOR THESE DRIVERS!

			Exiting .." 10 60
	exit 1
fi


# Exit if already updated
grep -q -E '^/lib/modules/2.4.26/kernel/drivers/block/loop_blowfish.o:.+loop.o' /lib/modules/2.4.26/modules.dep && exit


sudo rmmod loop 2>&1 | if grep -q 'Device or resource busy'; then
				aterm -e whiptail --backtitle 'UPDATE LOOP-AES' \
				--title 'ERROR' \
	--msgbox "	LOOP DRIVER IS IN USE
			(eg booted from iso?)
				
				Before testing new drivers:
				^^^^^^
				Free it
				then - 'rmmod loop'
				then - run this again.
				
			Bye!" 15 40
	kill $$
fi


# Update depfile

if [ -L /lib/modules/2.4.26/modules.dep ]; then
    sudo rm -rf /lib/modules/2.4.26/modules.*
    sudo cp /KNOPPIX/lib/modules/2.4.26/modules.* /lib/modules/2.4.26
fi

sudo depmod -a

aterm -e whiptail --backtitle 'UPDATE LOOP-AES' --title 'FINISHED' --msgbox 'Depfile updated' 10 20

exit 0